using System;

public class classifier_knn_modular {
public static void Main() {
modshogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");

Math.init_random(1);

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
//![create_features]

//![create_gmm_instance]
int num_components = 3;
GMM gmm = new GMM(num_components);
//![create_gmm_instance]

//![train_sample]
gmm.set_features(features_train);
gmm.train_em();
double[] output = gmm.sample();
//![train_sample]

//![training_smem]
gmm.train_smem();
//![training_smem]

//![extract_params]
int component_num = 1;
double[] nth_mean = gmm.get_nth_mean(component_num);
double[,] nth_cov = gmm.get_nth_cov(component_num);
double[] coef = gmm.get_coef();
//![extract_params]

//![cluster_output]
double[] log_likelihoods = gmm.cluster(nth_mean);
//![cluster_output]

// Serialize output for integration testing (automatically generated)
WrappedObjectArray __sg_storage = new WrappedObjectArray();
SerializableAsciiFile __sg_storage_file = new SerializableAsciiFile("gmm.dat", 'w');
__sg_storage.append_wrapped_int(num_components, "num_components");
__sg_storage.append_wrapped_real_vector(output, "output");
__sg_storage.append_wrapped_int(component_num, "component_num");
__sg_storage.append_wrapped_real_vector(nth_mean, "nth_mean");
__sg_storage.append_wrapped_real_matrix(nth_cov, "nth_cov");
__sg_storage.append_wrapped_real_vector(coef, "coef");
__sg_storage.append_wrapped_real_vector(log_likelihoods, "log_likelihoods");
__sg_storage.save_serializable(__sg_storage_file);

}
}
